// soutezici cislo 27

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls;

type
  TMap = (Wall, Road, RoadGood, Start, Finish, Invalid);
  TRouteType = (Normal, Reseted, Crash);
  TRoute = record // zde jsou ulozeny vysledne souradnice, cili ani zmena smeru, ani smer
    X : byte;
    Y : byte;
    RouteType : TRouteType;
  end;
  TfrmMain = class(TForm)
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuOpenMap: TMenuItem;
    mnuOpenRoute: TMenuItem;
    mnuLine1: TMenuItem;
    mnuQuit: TMenuItem;
    mnuGenerate: TMenuItem;
    dlgOpenMap: TOpenDialog;
    dlgSaveRoute: TSaveDialog;
    dlgOpenRoute: TOpenDialog;
    srlMap: TScrollBox;
    picMap: TImage;
    procedure mnuOpenMapClick(Sender: TObject);
    procedure mnuQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuGenerateClick(Sender: TObject);
    procedure mnuFileClick(Sender: TObject);
    procedure mnuOpenRouteClick(Sender: TObject);
  private
    { Private declarations }
    Zoom : byte;
    procedure DrawMap;
  public
    { Public declarations }
  end;

var
  Mapa : array of array of TMap;
  Visited : array of array of boolean;
  Route : array of TRoute;
  frmMain: TfrmMain;

implementation

{$R *.dfm}

// hledaci algoritmus je rekurzivni
// vyuziva pomocneho pole Visited, ktera oznacuje, zda jiz tento kus mapy byl vyzkousen, nebo ne
// telo algorimtu zjistuje, zda nedosahl cile -> vraci true a pricte dany pocet
// zda neskoncil na navstivenem policku -> vraci false - tudy cesta nevede
// pokud nenastal ani jeden z techto pripadu,
// hledaci algoritmus vyzkousi vsechny mozne zmeny smeru - zavolanim sama sebe
// a zjisti nejkratsi cestu
// podle nejkratsich cest provede zapis do pole FoundRoute
// uplne nejvrchnejsi funkce pote vezme foundroute a zapise jej do souboru

function FindWay(CurX, CurY, DirX, DirY : byte; var Count : integer, FoundRoute : array of TRoute) : boolean;
var
  TmpCount : array[1..10] of integer;
  WrkCount : integer;
  Iterator, MinCount : byte;
begin
  WrkCount := Count;
  MinCount := 10;
  for Iterator := 1 to 9 do TmpCount[Iterator] := -1;
  TmpCount[10] := 30000;
  // CurX, CurY = cil
  Visited[CurY][CurX] := true;
  if Mapa[CurY+DirY][CurX+DirX] = Finish then begin
    Result := true;
    Inc(Count);
    Exit;
  else if Visited[CurY+DirY][CurX+DirX] then begin
    Result := false;
    Exit;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX, DirY, WrkCount, FoundRoute) then begin
    TmpCount[1] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX+1, DirY, WrkCount, FoundRoute) then begin
    TmpCount[2] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX, DirY+1, Count3, FoundRoute) then begin
    TmpCount[3] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX-1, DirY, Count4, FoundRoute) then begin
    TmpCount[4] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX, DirY-1, Count5, FoundRoute) then begin
    TmpCount[5] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX+1, DirY+1, Count6, FoundRoute) then begin
    TmpCount[6] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX+1, DirY-1, Count7, FoundRoute) then begin
    TmpCount[7] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX-1, DirY+1, Count8, FoundRoute) then begin
    TmpCount[8] := WrkCount;
    WrkCount := Count;
  end;
  if FindWay(CurX + DirX, CurY + DirY, DirX-1, DirY-1, Count9, FoundRoute) then begin
    TmpCount[9] := WrkCount;
    WrkCount := Count;
  end;
  // ted zjistime, co nam zabralo nejmene casu
  for Iterator := 1 to 9 do begin
    if (TmpCount[Iterator] < TmpCount[MinCount]) and (TmpCount[Iterator] <> -1) then MinCount := Iterator;
  end;
  case MinCount of:
  // ...
  // na zaklada MinCount rozhodneme, ktera zmena smeru zabrala nejmene a pripiseme si foundroute
  // vratime navstevu zpatky
  Visited[CurY][CurX] := true;
end;

// slouzi ke konverzi znaku z mapoveho souboru na konstantu typu TMap
function ConvertCharToMap(MapChar : char) : TMap;
begin
  case MapChar of
    'X': Result := Wall;
    '.': Result := Road;
    ':': Result := RoadGood;
    'S': Result := Start;
    'C': Result := Finish;
    else Result := Invalid;
  end;
end;

// vraci barvicku, ktera se pouzije pri vykresleni mapy
function ConvertMapToColor(Map : TMap) : integer;
begin
  case Map of
    Wall: Result := $0; // ern
    Road: Result := $666666;
    RoadGood: Result := $999999;
    Start: Result := $FF0000;
    Finish: Result := $00FF00;
    else Result := 0;
  end;
end;

// vraci barvicku, ktera se pouzije pri kresleni cesty
function ConvertRouteToColor(RouteType : TRouteType) : integer;
begin
  case RouteType of
    Normal: Result := clWhite;
    Reseted: Result := clOlive;
    Crash: Result := clFuchsia;
    else Result := 0;
  end;
end;

// zkontroluje, zda je radek souboru mapy OK
function ValidMapLine(Line : string) : boolean;
var
  Iterator : byte;
begin
  for Iterator := 1 to Length(Line) do begin
    if ConvertCharToMap(Line[Iterator]) = Invalid then begin
      Result := false;
      Exit;
    end;
  end;
  Result := true;
end;

// zjisti, zda je jeden start
function ValidStart : boolean;
var
  Counter : integer;
  Iterator, Jiterator : byte;
begin
  Counter := 0;
  for Iterator := 0 to High(Mapa) do begin
    for Jiterator := 0 to High(Mapa[0]) do begin
      if Mapa[Iterator][Jiterator] = Start then begin
        Inc(Counter);
      end;
    end;
  end;
  Result := (Counter = 1);
end;

// zjisti, zda je spravny cil
function ValidFinish : boolean;
var
  Iterator, Jiterator : byte;
  JCount, ICount, MaxJCount : byte;
  Count : integer;
begin
  JCount := 0;
  MaxJCount := 0;
  ICount := 0;
  Count := 0;
  for Iterator := 0 to High(Mapa) do begin
    if JCount <> 0 then begin
      MaxJCount := JCount;
      JCount := 0;
    end;
    for Jiterator := 0 to High(Mapa[0]) do begin
      if (Mapa[Iterator][Jiterator] = Finish) then begin
        if JCount = 0 then begin
          inc(ICount);
        end;
        inc(JCount);
        inc(Count);
      end;
    end;
  end;
  JCount := MaxJCount;
  Result := ((Count <> 0) and (Count = ICount * JCount));
end;

// "vraci" souradnice startu
function FindStart(var X, Y : byte) : boolean;
var
  Iterator, Jiterator : byte;
begin
  for Iterator := 0 to High(Mapa) do begin
    for Jiterator := 0 to High(Mapa[0]) do begin
      if Mapa[Iterator][Jiterator] = Start then begin
        X := Jiterator;
        Y := Iterator;
      end;
    end;
  end;
end;

// vykresluje mapu vcetne cesty
procedure TfrmMain.DrawMap;
var
  Iterator, Jiterator : byte;
begin
  if Length(Mapa) = 0 then begin
    picMap.Picture := nil;
  end else begin
    picMap.Picture := nil;
    picMap.Height := Zoom * Length(Mapa);
    picMap.Width := Zoom * Length(Mapa[0]);
    picMap.Canvas.Refresh;
    picMap.Canvas.Pen.Style := psClear;
    for Iterator := 0 to High(Mapa) do begin
      for Jiterator := 0 to High(Mapa[0]) do begin
        with picMap.Canvas do begin
          Brush.Color := ConvertMapToColor(Mapa[Iterator][Jiterator]);
          Rectangle(Jiterator * Zoom, Iterator * Zoom, (Jiterator+1) * Zoom + 1, (Iterator+1) * Zoom + 1);
        end;
      end;
    end;
    if Length(Route) <> 0 then begin
      for Iterator := 0 to High(Route) do begin
        with picMap.Canvas do begin
          Brush.Color := ConvertRouteToColor(Route[Iterator].RouteType);
          Rectangle(Route[Iterator].X * Zoom, Route[Iterator].Y * Zoom, (Route[Iterator].X+1) * Zoom + 1, (Route[Iterator].Y+1) * Zoom + 1);
        end;
      end;
    end;
  end;
end;

// nacita mapu
procedure TfrmMain.mnuOpenMapClick(Sender: TObject);
var
  Line : string;
  MapFile : TextFile;
  LineLen, LineCount, Iterator : byte;
begin
  // el - nast mapu a dt ji zobrazit
  if dlgOpenMap.Execute then begin // pokud jsme vybrali mapu
    assignfile(MapFile, dlgOpenMap.FileName); // piadme soubor
    Reset(MapFile); // zaneme se tenm souboru
    LineCount := 0; // inicializace kontr. promnnch
    LineLen := 0;
    while not eof(MapFile) do begin // tec cyklus
      readln(MapFile, Line); // peteme dek
      // kontrola dat
      if Length(Line) > 255 then begin // pokud je dek kapnek dlouhej
        // seveme uivatele, e nm dal divn data
        Application.MessageBox('Byla pekroena maximln dlka dku'#13#10'Maximln dlka dku je 255 znak', 'Nelze nast mapu.', MB_ICONERROR);
        SetLength(Mapa, 0);
        DrawMap;
        Exit; // zrume natn
      end else if (Length(Line) <> LineLen) and (LineLen <> 0) then begin // njak mme v souboru rzn dlouh dky... tytyty, nenene ;-)
        Application.MessageBox('Data jsou patn uspodna', 'Nelze nast mapu.', MB_ICONERROR);
        SetLength(Mapa, 0);
        DrawMap;
        Exit;
      end else if Length(Line) = 0 then begin
        Application.MessageBox('Nadbyten poet przdnch dk!', 'Nelze nast mapu.', MB_ICONERROR);
        SetLength(Mapa, 0);
        DrawMap;
        Exit;
      end else if not ValidMapLine(Line) then begin // pokud dek obsahuje nesprvn znaky
        Application.MessageBox('patn formt dat', 'Nelze nast mapu.', MB_ICONERROR);
        SetLength(Mapa, 0);
        DrawMap;
        Exit;
      end;
      Inc(LineCount); // zvme poet dk o jedna - kvli kontrole, zda jsme neli pes
      LineLen := Length(Line); // zapeme si dlku dku
      if LineCount = 0 then begin // dolo k peteen
        Application.MessageBox('Soubor obsahuje pli mnoho dk (vce ne 255)','Nelze nast mapu' , MB_ICONERROR);
        SetLength(Mapa, 0);
        DrawMap;
        Exit;
      end;
      // provedeme zpis do promnn Mapa
      SetLength(Mapa, LineCount);
      SetLength(Mapa[LineCount-1], LineLen);
      SetLength(Visited, LineCount);
      SetLength(Visited[LineCount-1], LineLen);
      for Iterator := 1 to LineLen do begin
        Visited[LineCount-1][Iterator-1] := false;
      end;
    end;
    if not ValidStart then begin // zkontrolujeme, zda mme prv jeden start
      Application.MessageBox('Chyb start nebo je start pemnono','Nelze nast mapu' , MB_ICONERROR);
      SetLength(Mapa, 0);
      DrawMap;
      Exit;
    end else if not ValidFinish then begin // zkontrolujeme, zda mme sprvn cl
      Application.MessageBox('Chyb cl nebo nen obdlnkem','Nelze nast mapu' , MB_ICONERROR);
      SetLength(Mapa, 0);
      DrawMap;
      Exit;
    end;
    DrawMap;
  end;
end;

procedure TfrmMain.mnuQuitClick(Sender: TObject);
begin
  Close; // ukonme program
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Zoom := 5;
end;

procedure TfrmMain.mnuGenerateClick(Sender: TObject);
var
  Line : string;
  RouteFile : TextFile;
  LastX, LastY : byte;
  DirX, DirY : integer;
  dX, dY : integer;
begin
  if dlgSaveRoute.Execute then begin // chceme vygenerovat trasu
    // findway od poc sour s 0,0 smerem ...
    // zapis nalezene cesty do souboru ...
  end;
end;

procedure TfrmMain.mnuFileClick(Sender: TObject);
begin
  if Length(Mapa) = 0 then begin
    mnuGenerate.Enabled := false;
    mnuOpenRoute.Enabled := false;
  end else begin
    mnuGenerate.Enabled := true;
    mnuOpenRoute.Enabled := true;
  end;
end;

// nacteni trasy
procedure TfrmMain.mnuOpenRouteClick(Sender: TObject);
var
  Line : string;
  LineParts : TStrings;
  RouteFile : TextFile;
  LastX, LastY : byte;
  DirX, DirY : integer;
  dX, dY : integer;
begin
  if dlgOpenRoute.Execute then begin // chceme nast trasu
    assignfile(RouteFile, dlgOpenRoute.FileName);
    Reset(RouteFile);
    // inicializace promnnch
    FindStart(LastX, LastY);
    DirX := 0;
    DirY := 0;
    LineParts := TStringList.Create;
    while not eof(RouteFile) do begin
      ReadLn(RouteFile, Line);
      LineParts.CommaText := Line;
      if LineParts.Count <> 2 then begin
        // patn formt, je tu vce oddlen, ne m bt
        Application.MessageBox('Pli mnoho parametr','Nelze nast trasu' , MB_ICONERROR);
        SetLength(Route, 0);
        DrawMap;
        Exit;
      end else if (not TryStrToInt(LineParts.Strings[0], dX)) or (not TryStrToInt(LineParts.Strings[1], dY)) then begin
        // bez sel to asi nepjde - nco nen slo
        Application.MessageBox('Zmny smru nejsou dny sly','Nelze nast trasu' , MB_ICONERROR);
        SetLength(Route, 0);
        DrawMap;
        Exit;
      end else if (dX < -1) or (dX > 1) or (dY < -1) or (dY > 1) then begin
        // V Kocourkov nemaj tak siln brzdy/motory, aby uthly tak razantn zmnu smru
        Application.MessageBox('Chybn hodnoty - v Kocourkov nemaj tak siln vybaven','Nelze nast trasu' , MB_ICONERROR);
        SetLength(Route, 0);
        DrawMap;
        Exit;
      end;
      // proli jsme, provedeme vpoet trasy
      DirX := DirX + dX;
      DirY := DirY - dY;
      SetLength(Route, Length(Route)+1);
      Route[High(Route)].X := LastX + DirX;
      Route[High(Route)].Y := LastY + DirY;
      // bourali jsme?
      if (Mapa[LastY + DirY][LastX + DirX] = Wall) or (LastX + DirX > High(Mapa[0])) or (LastY + DirY > High(Mapa)) then begin
        //; // asi neudlme nic
        //LastX := LastX - DirX;
        //LastY := LastY - DirY;
        DirX := 0; // vynulujeme smr
        DirY := 0;
        Route[High(Route)].RouteType := Crash;
        Route[High(Route)-1].RouteType := Reseted;
      end else begin
        LastX := LastX + DirX;
        LastY := LastY + DirY;
        Route[High(Route)].RouteType := Normal;
      end;
    end;
    DrawMap;
  end;
end;

end.
